/* 
PSNR vZ 0.10

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define SOFTNAME "wpsnr"
#define VERSION "0.10"

#define MPOW(x) ((x) * (x)) 
#define L 0
#define R 1

typedef unsigned long ulong;
typedef unsigned short word;

typedef struct {
	ulong count;//Tv
	double diff[2];//2덷
} PSNR_CTX;

#pragma pack(push,1)
//wavt@C̃wb_
typedef struct{
	char RIFF[4];//"RIFF"
	ulong bytes;//(t@C̃oCg)-8
	char WAVE[4];// "WAVE" 
	char fmt[4];// "fmt "
	ulong siz_wf;//PCMWAVEFORMAT\̂̃oCg=16
	//PCMWAVEFORMAT\
	word wFormatTag; //ʂ1
	word nChannels; //`l
	ulong nSamplesPerSec; //TvO[g
	ulong nAvgBytesPerSec; //PbԂ̃oCg
	word nBlockAlign;  //1TvɕKvȃoCg ch * bits/8
	word wBitsPerSample;//ʎqrbg
	char data[4];//"data"
	ulong pcmbytes;//g`f[^̃oCg
} WAVHEADER;
#pragma pack(pop)



//PSNR_CTX0NA
void init_psnr(PSNR_CTX *pc)
{
	if (pc == NULL) return ;
	pc->diff[L] = pc->diff[R] = 0.0;
	pc->count = 0;
}

//2wavf[^pwav1, pwav22덷vZBnumɂ̓Tv
int process_psnr(PSNR_CTX *pc, signed short *pwav1,signed short *pwav2 , ulong num)
{
	ulong n;

	for (n=0; n<num;n+=2) {
		pc->diff[L] += MPOW(pwav1[n]-pwav2[n]);
		pc->diff[R] += MPOW(pwav1[n+1]-pwav2[n+1]);
	}
	pc->count += num/2;
	
	return num;
}

//PSNRvZpsnrdbPʂŕԂBpsnr[0]=Lch psnr[1]=RchɂȂBl333̂Ƃ͗򉻂ȂB
void result_psnr(PSNR_CTX *pc, double *psnr)
{
	psnr[L] = psnr[R] = 333;
	if (pc->diff[L] != 0.0) psnr[L] = 20 * log10(65535 / sqrt(pc->diff[L] / pc->count));
	if (pc->diff[R] != 0.0) psnr[R] = 20 * log10(65535 / sqrt(pc->diff[R] / pc->count));
}

main(int argc, char **argv)
{
	FILE *fp[2] = {NULL,NULL};
	signed short *buf[2] = {NULL,NULL};
	ulong cnt, read[2];
	PSNR_CTX pc;
	double psnr[2];
	WAVHEADER wh[2];
	int n;
	
	fprintf(stderr, "%s version %s\n", SOFTNAME, VERSION);
	
	if (argc < 3) {
		fprintf(stderr, "wavt@C2w肵ĂB\n");
		getchar();
		return -1;
	}

	for (n=0;n<2;n++) {
		fp[n] = fopen(argv[n+1], "rb");
		if (fp[n] == NULL) {
			fprintf(stderr, "t@CƊJ܂\n");
			goto END;
		}
		fread(&wh[n], sizeof(WAVHEADER), 1, fp[n]);
		if (memcmp(wh[n].RIFF, "RIFF", 4) != 0 ||
		    memcmp(wh[n].WAVE, "WAVE", 4) != 0 ||
			memcmp(wh[n].fmt , "fmt ", 4) != 0 ||
			memcmp(wh[n].data, "data", 4) != 0 ) {
			fprintf(stderr, "wavt@CƔFłȂߌvZł܂\n");
			goto END;
		}
	}
	
	if (wh[0].nSamplesPerSec != wh[1].nSamplesPerSec) {
		fprintf(stderr, "TvO[gقȂ邽ߌvZł܂\n");
		goto END;
	}
	
	if (wh[0].wBitsPerSample != wh[1].wBitsPerSample) {
		fprintf(stderr, "ʎqrbgقȂ邽ߌvZł܂\n");
		goto END;
	}
	
	cnt = wh[0].nSamplesPerSec *wh[0].nChannels;
	if (cnt == 0) {
		fprintf(stderr, "TvO[g܂̓`lȂߌvZł܂\n");
		goto END;
	}
	
	buf[0] = malloc(sizeof(signed short) *cnt);
	buf[1] = malloc(sizeof(signed short) *cnt);
	
	init_psnr(&pc);
	
	while (1) {
		read[0] = fread(buf[0], sizeof(signed short), cnt, fp[0]);
		read[1] = fread(buf[1], sizeof(signed short), cnt, fp[1]);
		
		if (read[0] == 0 || read[1] == 0) {
			fprintf(stderr, "\nvZIB\n");
			break;
		}
		if (read[0] != read[1]) {
			fprintf(stderr, "\nt@CTCYقȂ邽ߌvZ𒆒f܂B\n");
			break;
		}
		process_psnr(&pc, buf[0], buf[1], read[0]);
		
		result_psnr(&pc, psnr);
		printf("L%8.3fdB | R%8.3fdB | LR%8.3fdB\r",psnr[L], psnr[R], (psnr[L]+psnr[R])/2.0);
		
	}

END:
	for (n=0;n<2;n++) {
		if (fp[n] != NULL) fclose(fp[n]);
		free(buf[n]);
	}
	getchar();
}